//+------------------------------------------------------------------+
//|                                           FXG_iAlligatorZone.mq4 |
//|                                                 FXGeneral, 2010 |
//|                                        http://www.fxgeneral.com/ |
//+------------------------------------------------------------------+
#property copyright "FXGeneral, 2010"
#property link      "http://www.fxgeneral.com/"

#property indicator_separate_window    
#property  indicator_buffers 5         
#property  indicator_color1  Black     
#property  indicator_color2  Lime     
#property  indicator_color3  Red
#property  indicator_color4  Lime  
#property  indicator_color5  Red        

//---- indicator parameters 
extern bool    alert=true;
extern bool    write_file=true;
string         file_name="FXG_iAlligatorZone";
int            History    =3000;           

double     ExtBuffer0[];                
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];
datetime bar;

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
  bar=0;
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,2);
   SetIndexStyle(4,DRAW_HISTOGRAM,EMPTY,2);

   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);

   IndicatorShortName("Al_Zone");
//---- initialization done
   return(0);
  } 
//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- TODO: add your code here 


//---- 
   return(0); 
  } 
int start()                         //   start()
  {
   double jaw,teeth,lips,EMA4,close;                 
   int i,n,Counted_bars;
   string text;

   Counted_bars=IndicatorCounted(); //    
   i=Bars-Counted_bars-1;           //   
   if (i>History-1)                 //     ..
      i=History-1;                  // ..  .
      ExtBuffer1[i] = 0;            //     
      ExtBuffer2[i] = 0;
      ExtBuffer0[i] = 0;
      ExtBuffer3[i] = 0;
      ExtBuffer4[i] = 0;
      
   while(i>=0)                      //    
     {       
      jaw=iAlligator(Symbol(),Period(),13,8,8,5,5,3,MODE_SMMA,PRICE_MEDIAN,MODE_GATORJAW,i); // 
      teeth=iAlligator(Symbol(),Period(),13,8,8,5,5,3,MODE_SMMA,PRICE_MEDIAN,MODE_GATORTEETH,i); 
      lips=iAlligator(Symbol(),Period(),13,8,8,5,5,3,MODE_SMMA,PRICE_MEDIAN,MODE_GATORLIPS,i); 
      EMA4=iMA(NULL,0,1,1,MODE_SMMA,PRICE_MEDIAN,i); //
      close=iClose(NULL,0,i);
      ExtBuffer1[i] = 0;
      ExtBuffer2[i] = 0;
      ExtBuffer0[i] = 0; 
      ExtBuffer3[i] = 0; 
      ExtBuffer4[i] = 0; 
     
      if (close>jaw && close>teeth && close>lips)ExtBuffer1[i]=1; 
      if (close<jaw && close<teeth && close<lips)ExtBuffer2[i]=1;
      if (close>jaw && close>teeth && close>lips && close>EMA4)ExtBuffer3[i]=1;
      if (close<jaw && close<teeth && close<lips && close<EMA4)ExtBuffer4[i]=1;
      else ExtBuffer0[i] = 1;    
      
       
      
    if(i==1)  
     {
      if(write_file)
       {
        if(close>jaw && close>teeth && close>lips && lips>=teeth && teeth>=jaw && bar<Time[0])
         {
          text=TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS)+";     "+Symbol()+"_"+GetNameTF(Period())+"";

          WritingLineInFile(file_name+" "+TimeToStr(TimeCurrent(), TIME_DATE)+".txt",text);
         } 
        if(close<jaw && close<teeth && close<lips && lips<=teeth && teeth<=jaw && bar<Time[0])
         {
          text=TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS)+";     "+Symbol()+"_"+GetNameTF(Period())+"";
          WritingLineInFile(file_name+" "+TimeToStr(TimeCurrent(), TIME_DATE)+".txt",text);
         } 
       }
      if(alert)
       {
        if(close>jaw && close>teeth && close>lips && lips>=teeth && teeth>=jaw && bar<Time[0])
         {
          Alert ("Alligator_Zone:     "+Symbol()+"_"+GetNameTF(Period())+"");
          bar=Time[0];
         }
        if(close<jaw && close<teeth && close<lips && lips<=teeth && teeth<=jaw && bar<Time[0])   
         {
         Alert ("Alligator_Zone:     "+Symbol()+"_"+GetNameTF(Period())+"");
         bar=Time[0];
         }
       }
     }   
      i--;                          //    
     }
   return;                          //   . - start()
  }

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//+----------------------------------------------------------------------------+
//|   :                                               |
//|  :                                                                |
//|    FileName -                                                      |
//|    text     -                                                        |
//+----------------------------------------------------------------------------+
void WritingLineInFile(string FileName, string text) {
  int file_handle=FileOpen(FileName, FILE_READ|FILE_WRITE, " ");

  if (file_handle>0) {
    FileSeek (file_handle, 0, SEEK_END);
    FileWrite(file_handle, text);
    FileClose(file_handle);
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TimeFrame -  ( )      (0 -  )         |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:         return("Unknown Period");
  }
}